#include "gdk_imlib.h"
#include <gtk/gtk.h>

GtkWidget *Fenetre, *Table, *Dessin, *Label, *Entry, *Load, *MenuBar, *BarItem1, *BarItem2, *Menu1, *Menu2, *Menu2ItemAbout, *MenuItemLoad, *MenuItemSep;
GtkWidget *MenuItemQuit, *Boite, *Fen_quit, *Fen_about, *Fen_load, *Entry_img;
GdkPixmap *pixmap;
GdkImlibImage *image;


static gboolean Redimensionne(GtkWidget *Dessin, GdkEventConfigure *ev, GdkImlibImage *image) {
  
  GdkPixmap *pixmap;
  
  gdk_imlib_render(image, ev->width, ev->height);
  pixmap = gdk_imlib_move_image(image);
  gdk_window_set_back_pixmap(Dessin->window, pixmap, 0);
  gdk_window_clear(Dessin->window);
  return TRUE;

}

// About

gboolean about ( GtkWidget *widget, gpointer data ) {
  
  GtkWidget *OK_Bouton, *Texte;
  GtkWidget *Table_about;
  
  Table_about = gtk_table_new(2, 2, TRUE);
  Fen_about = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  Texte = gtk_label_new("PView - Par Max.Peta - (c) 2000");
  OK_Bouton = gtk_button_new_with_label("Ok");
  
  gtk_signal_connect_object(GTK_OBJECT(OK_Bouton), "button_press_event", GTK_SIGNAL_FUNC(gtk_widget_hide), GTK_OBJECT(Fen_about));
    
  gtk_table_attach_defaults(GTK_TABLE(Table_about), Texte, 0, 2, 0, 1);
  gtk_table_attach_defaults(GTK_TABLE(Table_about), OK_Bouton, 0, 2, 1, 2);
  
  gtk_container_add(GTK_CONTAINER(Fen_about), Table_about);
  gtk_window_set_title(GTK_WINDOW(Fen_about), "About ...");

  gtk_widget_show_all(Fen_about);

  return(TRUE);
}


// Quit


gboolean delete_event ( GtkWidget *widget, gpointer data ) {
  
  GtkWidget *OUI_Bouton, *NON_Bouton, *Texte;
  GtkWidget *Table_quit;
  
  Table_quit = gtk_table_new(2, 2, TRUE);
  Fen_quit = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  Texte = gtk_label_new("Voulez-vous vraiment quitter ?");
  OUI_Bouton = gtk_button_new_with_label("Oui");
  NON_Bouton = gtk_button_new_with_label("Non");
  
  gtk_signal_connect(GTK_OBJECT(OUI_Bouton), "button_press_event", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  gtk_signal_connect_object(GTK_OBJECT(NON_Bouton), "button_press_event", GTK_SIGNAL_FUNC(gtk_widget_hide), GTK_OBJECT(Fen_quit));
  
  gtk_table_attach_defaults(GTK_TABLE(Table_quit), Texte, 0, 2, 0, 1);
  gtk_table_attach_defaults(GTK_TABLE(Table_quit), OUI_Bouton, 0, 1, 1, 2);
  gtk_table_attach_defaults(GTK_TABLE(Table_quit), NON_Bouton, 1, 2, 1, 2);

  gtk_container_add(GTK_CONTAINER(Fen_quit), Table_quit);
  gtk_window_set_title(GTK_WINDOW(Fen_quit), "Quitter ...");

  gtk_widget_show_all(Fen_quit);

  return(TRUE);
}

void ok( void ) {



  image = gdk_imlib_load_image(gtk_entry_get_text(GTK_ENTRY(Entry_img)));

  if(image) {

  gtk_drawing_area_size(GTK_DRAWING_AREA(Dessin), image->rgb_width, image->rgb_height);
  gtk_signal_connect(GTK_OBJECT(Dessin), "configure_event", (GtkSignalFunc)Redimensionne, image);
  gdk_imlib_render(image, image->rgb_width, image->rgb_height);
  pixmap = gdk_imlib_move_image(image);
  gdk_window_set_back_pixmap(Dessin->window, pixmap, 0);
  gtk_label_set_text(GTK_LABEL(Label), "Log : Ok");
  gdk_window_clear(Dessin->window);
  } else { 
  
    gtk_label_set_text(GTK_LABEL(Label), "Log : Fichier introuvable !");
  
  }
  
  gtk_widget_hide(Fen_load);

}

void load( void ) {

  GtkWidget *Table, *Label, *Ok, *Annule;

  Fen_load = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  Entry_img = gtk_entry_new();
  Table = gtk_table_new(2, 2, TRUE);
  Label = gtk_label_new("Charger");
  Ok = gtk_button_new_with_label("Ok");
  Annule = gtk_button_new_with_label("Annuler");

  gtk_window_set_title(GTK_WINDOW(Fen_load), "Charger ...");
  
  gtk_container_add(GTK_CONTAINER(Fen_load), Table);
  gtk_table_attach_defaults(GTK_TABLE(Table), Label, 0, 2, 0, 1);
  gtk_table_attach_defaults(GTK_TABLE(Table), Entry_img, 0, 2, 1, 2);
  gtk_table_attach_defaults(GTK_TABLE(Table), Ok, 0, 1, 2, 3);
  gtk_table_attach_defaults(GTK_TABLE(Table), Annule, 1, 2, 2, 3);

  gtk_widget_show_all(Fen_load);

  gtk_signal_connect(GTK_OBJECT(Ok), "button_press_event", GTK_SIGNAL_FUNC(ok), NULL);
  gtk_signal_connect_object(GTK_OBJECT(Annule), "button_press_event", GTK_SIGNAL_FUNC(gtk_widget_hide), GTK_OBJECT(Fen_load));


}
                                        
void init( void ) {

  Fenetre = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  Table = gtk_table_new(4, 4, TRUE);
  Dessin = gtk_drawing_area_new();
  MenuBar = gtk_menu_bar_new();
  Label = gtk_label_new("Log :");
  Boite = gtk_vbox_new(FALSE, 5);
  BarItem1 = gtk_menu_item_new_with_label("PView");
  BarItem2 = gtk_menu_item_new_with_label("?");
  Menu1 = gtk_menu_new();
  Menu2 = gtk_menu_new();
  MenuItemLoad = gtk_menu_item_new_with_label("Charger ...");
  MenuItemSep = gtk_menu_item_new();
  MenuItemQuit = gtk_menu_item_new_with_label("Quitter");
  Menu2ItemAbout = gtk_menu_item_new_with_label("About ...");
  
  gtk_window_set_title(GTK_WINDOW(Fenetre), "PView ...");
  gtk_widget_push_visual(gdk_imlib_get_visual());
  gtk_widget_push_colormap(gdk_imlib_get_colormap());

}

void pack( void ) {

  gtk_container_add(GTK_CONTAINER(Fenetre), Boite);

  gtk_box_pack_start_defaults(GTK_BOX(Boite), MenuBar);
  gtk_box_pack_start_defaults(GTK_BOX(Boite), Table);

  gtk_menu_bar_append(GTK_MENU_BAR(MenuBar), BarItem1);
  gtk_menu_bar_append(GTK_MENU_BAR(MenuBar), BarItem2);

  gtk_menu_item_set_submenu(GTK_MENU_ITEM(BarItem1), Menu1);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(BarItem2), Menu2);

  gtk_menu_append(GTK_MENU(Menu1), MenuItemLoad);
  gtk_menu_append(GTK_MENU(Menu1), MenuItemSep);
  gtk_menu_append(GTK_MENU(Menu1), MenuItemQuit);
  gtk_menu_append(GTK_MENU(Menu2), Menu2ItemAbout);

  gtk_table_attach_defaults(GTK_TABLE(Table), Dessin, 0, 4, 0, 3);
  gtk_table_attach_defaults(GTK_TABLE(Table), Label, 0, 4, 3, 4);
  
  gtk_widget_show_all(Fenetre);


}

int main( int argc, char *argv[] ) {

  gtk_init(&argc, &argv);
  gdk_imlib_init();

  init();
  pack();
  
  gtk_signal_connect(GTK_OBJECT(Fenetre), "delete_event", GTK_SIGNAL_FUNC(delete_event), NULL);
  gtk_signal_connect(GTK_OBJECT(Fenetre), "destroy", GTK_SIGNAL_FUNC(delete_event), NULL);
  gtk_signal_connect(GTK_OBJECT(MenuItemQuit), "activate", GTK_SIGNAL_FUNC(delete_event), NULL);
  gtk_signal_connect(GTK_OBJECT(Menu2ItemAbout), "activate", GTK_SIGNAL_FUNC(about), NULL);
  gtk_signal_connect(GTK_OBJECT(MenuItemLoad), "activate", GTK_SIGNAL_FUNC(load), NULL);
 
  gtk_main();

  return 0;

}


